﻿* Encoding: UTF-8.
*Matrix comparisons
*SPSS macros by Kirill Orlov
*kior@comtv.ru, ttnphns@gmail.com
*https://www.spsstools.net/en/KO-spssmacros
*All rights reserved.

*/*!KO_DMATRIX*/***********************************************.
define !KO_dmatrix(cols= !charend('/') /trans= !charend('/') /measure= !charend('/'))
set mxloops 10000 results none.
flip vari= !cols /newname= varname_.
set results list.
matrix.
get m /vari= !cols /names= names.
comp m= t(m).
comp p= ncol(m).
comp d= make(p,p,0).
loop i= 1 to p-1.
-loop j= i+1 to p.
- comp v= 0.
- loop ind= 1 to p.
-  do if ind<>i and ind<>j.
-   comp v= {v,ind}.
-  end if.
- end loop.
- comp v= v(2:(p-1)).
- comp ci= m(v,i).
- comp cj= m(v,j).
  !if (!trans='CENTER' !or !trans='ZSCORE') !then
-  comp ci= ci-msum(ci)/(p-2).
-  comp cj= cj-msum(cj)/(p-2).
  !ifend
  !if (!trans='MEANSS' !or !trans='ZSCORE') !then
-  do if any(ci<>0).
-   comp ci= ci/sqrt(mssq(ci)/(p-2)).
-  end if.
-  do if any(cj<>0).
-   comp cj= cj/sqrt(mssq(cj)/(p-2)).
-  end if.
  !ifend
  !if (!trans='RANGE') !then
-  do if mmax(ci)>mmin(ci).
-   comp ci= ci/(mmax(ci)-mmin(ci)).
-  end if.
-  do if mmax(cj)>mmin(cj).
-   comp cj= cj/(mmax(cj)-mmin(cj)).
-  end if.
  !ifend
  !if (!trans='RESCALE') !then
-  do if mmax(ci)>mmin(ci).
-   comp ci= (ci-mmin(ci))/(mmax(ci)-mmin(ci)).
-  else.
-   comp ci= .5.
-  end if.
-  do if mmax(cj)>mmin(cj).
-   comp cj= (cj-mmin(cj))/(mmax(cj)-mmin(cj)).
-  else.
-   comp cj= .5.
-  end if.
  !ifend
- comp dv= abs(ci-cj).
  !if (!measure='EUCLID' !or !measure='SEUCLID') !then
-  comp dv= dv&**2.
  !ifend
- comp d(i,j)= msum(dv).
-end loop.
end loop.
!if (!measure='EUCLID') !then
-comp d= sqrt(d).
!ifend
comp d= d+t(d).
comp rn= {make(p,1,'PROX'),t(names)}.
comp names= {'rowtype_','varname_',names}.
save {rn,d} /outfile= * /names= names /strings= rowtype_ varname_.
end matrix.
val lab rowtype_ 'PROX' !quote(!concat('DISSIMILARITY ',!measure)).
!enddefine.

*/*!KO_CMPRMX1*/***********************************************.
define !KO_cmprmx1(matr= !charend('/') /cols= !charend('/') /triang= !charend('/') /elem= !charend('/') /measure= !charend('/') /norm= !charend('/') /output= !charend('/'))
set mxloops 1000.
!if (!measure='BLOCK' !or !measure=!null) !then !let !d= 'msum(abs(m1-m2))' !let !sum= 'msum(abs(m))' !else !let !d= 'mssq(m1-m2)' !let !sum= 'mssq(m)' !ifend
matrix.
comp ovlsum= 0.
!if (!output='YES') !then
-print /title 'Номера матриц:'.
!ifend
!let !mtr= !matr !let !lab= !null !let !mnames= !null
!do !ind= 1 !to 999
 !let !m= !head(!mtr) !let !mtr= !tail(!mtr)
 !let !lab= !concat(!lab,' ','mx',!ind,' ',!m) !let !mnames= !concat(!mnames,',',!quote(!concat('mx',!ind)))
 !if (!output='YES') !then
- print /title !quote(!concat(!ind,'  ',!unquote(!m))).
 !ifend
 !if (!cols='ALL' !or !cols=!null) !then
- get m /file= !m /vari= all /names= names /miss= 0.
- do if names(1)='ROWTYPE_' or names(1)='rowtype_'.
-  comp m= m(:,2:ncol(m)).
- end if.
- do if names(1)='VARNAME_' or names(2)='VARNAME_' or names(1)='varname_' or names(2)='varname_'.
-  comp m= m(:,2:ncol(m)).
- end if.
 !else
- get m /file= !m /vari= !cols /names= names /miss= 0.
- get varname /file= !m /vari= varname_.
- comp indxs= 0.
- loop c= 1 to ncol(m).
-  loop r= 1 to nrow(m).
-   do if varname(r)=names(c).
-    comp indxs= {indxs;r}.
-    break.
-   end if.
-  end loop.
- end loop.
- comp m= m(indxs(2:nrow(indxs)),:).
 !ifend
-comp nc= ncol(m).
-call setdiag(m,0).
 !if (!triang<>'BOTH' !and !triang<>!null) !then
  !if (!triang='LOWER') !then
-  comp m= t(m).
  !ifend
- loop i= 1 to nc-1.
-  comp m((nc-i+1):nc,1:i)= m((nc-i+1):nc,1:i)&*(not ident(i)).
- end loop.
 !ifend
 !if (!elem='ABS') !then
- comp m= abs(m).
 !ifend
 !if (!elem='SQUARE') !then
- comp m= m&**2.
 !ifend
-save m /outfile= !quote(!concat('temp_KO_cmprmx_',!ind,'.sav')).
 !if (!norm='YES') !then
- comp ovlsum= ovlsum+!sum.
 !ifend
 !if (!mtr=!null) !then !break !ifend
!doend
 !if (!norm='YES') !then
- write ovlsum /outfile= 'temp_KO_cmprmx_0.sps' /field= 1 to 32.
 !ifend
end matrix.
matrix.
comp m= make(!ind,!ind,0).
!do !i= 1 !to !ind
 !if (!i=!ind) !then !break !ifend
-get m1 /file= !quote(!concat('temp_KO_cmprmx_',!i,'.sav')).
 !do !i2= !length(!concat(!blanks(!i),' ')) !to !ind
- get m2 /file= !quote(!concat('temp_KO_cmprmx_',!i2,'.sav')).
- comp m(!i,!i2)= !d.
 !doend
!doend
comp m= m+t(m).
!if (!norm='YES') !then !let !ntxt= ', нормированное величиной элементов всех матриц'
-read ovlsum /file= 'temp_KO_cmprmx_0.sps' /field= 1 to 32 /size= 1.
-comp m= !ind*m/ovlsum.
!ifend
!if (!measure='EUCLID') !then
-comp m= sqrt(m).
!ifend
!if (!output='YES') !then
-comp out= {0,0,0}.
-loop i= 1 to !ind-1.
- comp out= {out;make(!ind-i,1,i),t((i+1):!ind),m((i+1):!ind,i)}.
-end loop.
 !if (!measure='BLOCK' !or !measure=!null) !then !let !meas= !concat('Манхэттенское расстояние',!ntxt) !ifend
 !if (!measure='EUCLID') !then !let !meas= !concat('Евклидово расстояние',!ntxt) !ifend
 !if (!measure='SEUCLID') !then !let !meas= !concat('Квадр. евклидово расстояние',!ntxt) !ifend
-print out(2:nrow(out),:) /clabels= 'Матрица' 'Матрица' 'D' /title= !quote(!meas).
-comp sumd= csum(out(:,3)).
-print sumd /title= 'Сумма D'.
-print (sumd/(nrow(out)-1)) /title= 'Среднее D'.
!ifend
comp mnames= {!tail(!mnames)}.
comp names= {'rowtype_','varname_',mnames}.
comp rowtype= make(nrow(m),1,'PROX').
save {rowtype,t(mnames),m} /outfile= * /names= names /strings= rowtype_ varname_.
end matrix.
var lab !lab.
val lab rowtype_ 'PROX' !quote(!concat('DISSIMILARITY ',!measure)).
!do !i= 1 !to !ind
-erase file !quote(!concat('temp_KO_cmprmx_',!i,'.sav')). 
!doend
!if (!norm='YES') !then
-erase file 'temp_KO_cmprmx_0.sps'. 
!ifend
!enddefine.

*/*!KO_CMPRMX2*/***********************************************.
define !KO_cmprmx2(matr= !charend('/') /cols= !charend('/') /triang= !charend('/') /elem= !charend('/') /measure= !charend('/') /norm= !charend('/') /output= !charend('/'))
set mxloops 10000.
matrix.
!if (!output='YES') !then
-print /title 'Номера матриц:'.
!ifend
comp mnames= ' '.
!let !mtr= !matr !let !lab= !null
!do !i= 1 !to 999
 !let !m= !head(!mtr) !let !mtr= !tail(!mtr) !let !lab= !concat(!lab,' ','mx',!i,' ',!m)
-comp mnames= {mnames,!quote(!concat('MX',!i))}.
 !if (!output='YES') !then
- print /title !quote(!concat(!i,'  ',!unquote(!m))).
 !ifend
 !if (!cols='ALL' !or !cols=!null) !then
- get m /file= !m /vari= all /names= names /miss= 0.
- do if names(1)='ROWTYPE_' or names(1)='rowtype_'.
-  comp m= m(:,2:ncol(m)).
- end if.
- do if names(1)='VARNAME_' or names(2)='VARNAME_' or names(1)='varname_' or names(2)='varname_'.
-  comp m= m(:,2:ncol(m)).
- end if.
 !else
- get m /file= !m /vari= !cols /names= names.
- get varname /file= !m /vari= varname_.
- comp indxs= 0.
- loop c= 1 to ncol(m).
-  loop r= 1 to nrow(m).
-   do if varname(r)=names(c).
-    comp indxs= {indxs;r}.
-    break.
-   end if.
-  end loop.
- end loop.
- comp m= m(indxs(2:nrow(indxs)),:).
 !ifend
-comp nc= ncol(m).
-call setdiag(m,0).
 !if (!triang<>'BOTH' !and !triang<>!null) !then
  !if (!triang='LOWER') !then
-  comp m= t(m).
  !ifend
- loop i= 1 to nc-1.
-  comp m((nc-i+1):nc,1:i)= m((nc-i+1):nc,1:i)&*(not ident(i)).
- end loop.
 !ifend
 !if (!i>1) !then !let !mxs= 'mxs,' !ifend
-comp mxs= {!mxs reshape(m,nc**2,1)}.
 !if (!mtr=!null) !then !break !ifend
!doend
!if (!elem='ABS') !then
-comp mxs= abs(mxs).
!ifend
!if (!elem='SQUARE') !then
-comp mxs= mxs&**2.
!ifend
comp m= make(!i,!i,0).
loop i= 1 to nrow(mxs).
-comp kmi= kroneker(make(ncol(mxs),1,1),mxs(i,:)).
 !if (!measure='EUCLID' !or !measure='SEUCLID') !then !let !sum='mssq'
- comp m= m+(kmi-t(kmi))&**2.
 !else !let !sum='msum'
- comp m= m+abs(kmi-t(kmi)).
 !ifend
end loop.
!if (!norm='YES') !then !let !ntxt= ', нормированное величиной элементов всех матриц'
-comp m= !i*m/!sum(abs(mxs)).
!ifend
!if (!measure='EUCLID') !then
-comp m= sqrt(m). 
!ifend
release mxs,kmi.
!if (!output='YES') !then
-comp out= {0,0,0}.
-loop i= 1 to !i-1.
- comp out= {out;make(!i-i,1,i),t((i+1):!i),m((i+1):!i,i)}.
-end loop.
 !if (!measure='BLOCK' !or !measure=!null) !then !let !meas= !concat('Манхэттенское расстояние',!ntxt) !ifend
 !if (!measure='EUCLID') !then !let !meas= !concat('Евклидово расстояние',!ntxt) !ifend
 !if (!measure='SEUCLID') !then !let !meas= !concat('Квадр. евклидово расстояние',!ntxt) !ifend
-print out(2:nrow(out),:) /clabels= 'Матрица' 'Матрица' 'D' /title= !quote(!meas).
-comp sumd= csum(out(:,3)).
-print sumd /title= 'Сумма D'.
-print (sumd/(nrow(out)-1)) /title= 'Среднее D'.
!ifend
comp mnames= mnames(2:ncol(mnames)).
comp names= {'rowtype_','varname_',mnames}.
comp rowtype= make(nrow(m),1,'PROX').
save {rowtype,t(mnames),m} /outfile= * /names= names /strings= rowtype_ varname_.
end matrix.
var lab !lab.
val lab rowtype_ 'PROX' !quote(!concat('DISSIMILARITY ',!measure)).
!enddefine.
